



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>开源项目AndroidUtil-采用Fragment实现TabHost</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">开源项目AndroidUtil-采用Fragment实现TabHost</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-19 19:17:24 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>原文出自：方杰|<a href="http://fangjie.info/?p=141" rel="external nofollow noreferrer">http://fangjie.info/?p=141</a><strong>&nbsp;</strong><strong>转载请注明出处</strong></p>
<p>学习Android也有一段时间了，感觉大部分的Android应用都有很多类似的组件，所以就打算做了这样一个开源项目，目的是整合一些Android开发常用的组件Demo，方便以后项目中直接拿来用。git地址：<a href="https://github.com/JayFang1993/AndroidUtil" rel="external nofollow noreferrer">https://github.com/JayFang1993/AndroidUtil</a></p>
<p>废话不多说，首先讲第一个常用的组件TabHost的实现。之前我们可以通过继承TabActivity来实现，后来的API中已经不建议用这种方式了，所以今天我们主要讲的是用Fragment来实现Tabhost。<br />
	在新浪微博等很多APP中都有底部选项卡TabHost。首先看下实现后的效果。</p>
<p><img referrerpolicy="no-referrer"src="http://fangjie.sinaapp.com/upload/images/tabhost.png" /></p>
<p>一、TabHost的实现</p>
<p>Tabhost的每一个选项卡是通过RadioGroup实现的，每一个Tab就是一个RadioButton。页面除TabHost以外的内容区域是Fragment。下面是具体的布局文件main.xml</p>
<div>
<pre class="prettyprint linenums">&lt;RelativeLayout xmlns:android="http://schemas.android.com/apk/res/android"
    xmlns:tools="http://schemas.android.com/tools"
    android:layout_width="match_parent"
    android:layout_height="match_parent"
    tools:context=".MainActivity" &gt;
    &lt;TextView
        android:layout_width="fill_parent"
        android:layout_height="48dp"
        android:layout_centerHorizontal="true"
        android:gravity="center"
        android:id="@+id/title"
        android:text="昌大软院"
        android:textSize="18dp"
        android:textColor="#a8aeb5"
        android:typeface="monospace"
        android:background="@drawable/title_bg" /&gt;
    &lt;Button
        android:layout_width="wrap_content"
        android:layout_height="wrap_content"
        android:layout_alignParentRight="true"
        android:text="Done"
        android:textColor="#a8aeb5"
        android:layout_marginTop="10dp"
        android:layout_marginRight="8dp"
        android:background="@drawable/done" /&gt;
    &lt;Button
        android:layout_width="wrap_content"
        android:layout_height="wrap_content"
        android:background="@drawable/back"
        android:textColor="#a8aeb5"
        android:text="Back"
        android:layout_alignParentLeft="true"
        android:layout_marginTop="10dp"
        android:layout_marginLeft="8dp"
        /&gt;

    &lt;FrameLayout
         android:id="@+id/content"
         android:layout_below="@id/title"
         android:layout_width="fill_parent"
         android:layout_height="fill_parent"/&gt; 

    &lt;RadioGroup
        android:id="@+id/main_radio"
        android:layout_width="fill_parent"
        android:layout_height="48dp"
        android:layout_gravity="bottom"
        android:orientation="horizontal"
        android:layout_alignParentBottom="true"
        android:background="@drawable/tabhost_bg" &gt;
        &lt;RadioButton
            android:id="@+id/rb_home"
            android:drawableTop="@drawable/tab1"
            style="@style/tab"
            android:text="主页" /&gt;
        &lt;RadioButton
            android:id="@+id/rb_at"
            style="@style/tab"
            android:drawableTop="@drawable/tab2"
            android:text="收藏夹" /&gt;
        &lt;RadioButton
            android:id="@+id/rb_mess"
            style="@style/tab"
            android:drawableTop="@drawable/tab3"
            android:text="我" /&gt;
        &lt;RadioButton
            android:id="@+id/rb_more"
            style="@style/tab"
            android:drawableTop="@drawable/tab4"
            android:text="更多" /&gt;
    &lt;/RadioGroup&gt;
&lt;/RelativeLayout&gt;</pre>
</div>
<p>每一个Tab的样式：宽度、高度、背景图片这些都是相同的。所以写在了一个style文件中。styles.xml</p>
<div>
<pre class="prettyprint linenums">&lt;resources xmlns:android="http://schemas.android.com/apk/res/android"&gt;
    &lt;style name="tab"&gt;
        &lt;item name="android:layout_height"&gt;48dp&lt;/item&gt;
        &lt;item name="android:layout_width"&gt;match_parent&lt;/item&gt;
        &lt;item name="android:layout_weight"&gt;1&lt;/item&gt;
        &lt;item name="android:gravity"&gt;center&lt;/item&gt;
        &lt;item name="android:textSize"&gt;10dp&lt;/item&gt;
        &lt;item name="android:paddingTop"&gt;8dp&lt;/item&gt;
        &lt;item name="android:background"&gt;@drawable/tabhost_bg_selector&lt;/item&gt;
        &lt;item name="android:textColor"&gt;#a8aeb5&lt;/item&gt;
        &lt;item name="android:button"&gt;@null&lt;/item&gt;
    &lt;/style&gt;
&lt;/resources&gt;</pre>
</div>
<p>为了能够制造出Tab按下选中的效果，所以为Tab的背景设计了一个selector。tabhost_bg_selector.xml</p>
<div>
<pre class="prettyprint linenums">&lt;selector xmlns:android="http://schemas.android.com/apk/res/android"&gt;
    &lt;item android:drawable="@drawable/tabhost_press"  android:state_pressed="true" /&gt;
    &lt;item android:drawable="@drawable/tabhost_press" android:state_checked="true" /&gt;
    &lt;item android:drawable="@drawable/tabhost_bg"/&gt;
&lt;/selector&gt;</pre>
</div>
<p>至此，关于TabHost的所有布局文件都写完了。下面看看Activity中的Java代码。MainActivity.java</p>
<div>
<pre class="prettyprint linenums">public class MainActivity extends FragmentActivity {
    private FragmentManager fragmentManager;
    private RadioGroup radioGroup;
    private RadioButton rb1;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        fragmentManager = getSupportFragmentManager();
        radioGroup = (RadioGroup) findViewById(R.id.main_radio);
        rb1=(RadioButton) findViewById(R.id.rb_home);
        radioGroup.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @SuppressLint("NewApi")
        public void onCheckedChanged(RadioGroup group, int checkedId) {
                rb1.setBackgroundDrawable(getResources().getDrawable(R.drawable.tabhost_bg_selector));
                FragmentTransaction transaction = fragmentManager.beginTransaction();
                ContentFrame fragment = null;
                switch(checkedId)
                {
                    case 0:
                        fragment= new ContentFrame();
                        break;
                    case 1:
                        fragment= new ContentFrame();
                        break;
                    case 2:
                        fragment= new ContentFrame();
                        break;
                    case 3:
                        fragment= new ContentFrame();
                        break;
                    default:
                        fragment= new ContentFrame();
                        break;
                }
                transaction.replace(R.id.content, (Fragment)fragment);
                transaction.commit();
            }
        });
        //设置默认选中第一项
        radioGroup.check(1);
        radioGroup.check(0);
        //设置按下的背景效果
        rb1.setBackgroundDrawable(getResources().getDrawable(R.drawable.tabhost_press));
    }
}</pre>
</div>
<p>针对每一个选项卡的内容界面代码，随便写一个布局文件content.xml</p>
<div>
<pre class="prettyprint linenums">&lt;LinearLayout xmlns:android="http://schemas.android.com/apk/res/android"
    android:layout_width="match_parent"
    android:layout_height="match_parent"
    android:orientation="vertical" &gt;
    &lt;TextView
        android:layout_width="match_parent"
        android:layout_height="match_parent"
        android:id="@+id/content"
        /&gt;
&lt;/LinearLayout&gt;</pre>
</div>
<p>内容部分的Java代码，实现和Activity差不多，不过这里需要继承Fragment而不是Activity。从content.xml中得到一个View，然后将这个View替换Main中的Fragment部分。</p>
<div>
<pre class="prettyprint linenums">public class ContentFrame extends Fragment{
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.content, null);
        TextView textView = (TextView) view.findViewById(R.id.content);
        textView.setText("Hello world");
        return view;
    }
}</pre>
</div>
<p><strong>&nbsp;补充</strong>：以上代码是考虑到Android 3.0以前API中没有Fragment，导入android-support-v4.jar后的代码，有几点区别：</p>
<ol><li>3.0之前的应该导入 &nbsp;import android.support.v4.app.*; 这个包中Fragment相关类；3.o之后的可以直接导入android.app.*;</li>
<li>3.0之前的MainAcitivity要继承自FragmentActivity，3.0之后的直接继承自Activity;</li>
<li>3.0之前&nbsp; &nbsp;fragmentManager = getSupportFragmentManager();3.0之后&nbsp;&nbsp;fragmentManager = getFragmentManager();</li></ol>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxnd2j8.html">pc端与移动端的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gyxl49.html">iOS中的&num;ifdef  DEBUG为什么会在didFinishLaunchingWithOptions之前执行</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q24kyw8.html">iOS开发&mdash;&mdash;高级技术&amp;amp&semi;通讯录功能的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1106d9.html">hadoop版本比较  &lbrack;转&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv713yq.html">iOS开发&mdash;&mdash;swift精讲&amp;amp&semi;MVC应用实战</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pje3049.html">jQuery与XML</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdevwjz9.html">浅谈Redis及其安装配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpovj39.html">Js控制iphone端的input&sol;textarea元素失去焦点时隐藏键盘</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgn3678.html">ogg 初始化</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoedevq.html">Less的嵌套规则</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpwlp59.html">&dollar;A&comma;B&dollar; 实对称  &dollar;&bsol;ra&bsol;tr&lpar;&lpar;AB&rpar;&Hat;2&rpar;&bsol;leq &bsol;tr&lpar;A&Hat;2B&Hat;2&rpar;&dollar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvmv4j8.html">Java类的加载和对象创建流程的详细分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwp1ek8.html">官宣 &excl; 52abp&lowbar;Pro版本低调上线</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyykw3gq.html">linux：NFS</a>
		</li>
						<li><a href="https://www.batexi.com/a/953rjdz8.html">css动画，展开折叠图标</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnlwo7q.html">20145302张薇《网络对抗技术》PC平台逆向破解</a>
		</li>
						<li><a href="https://www.batexi.com/a/902om0nq.html">【欧拉定理】BZOJ3884-上帝与集合的正确用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r42omr8.html">前端存储之Web Sql Database</a>
		</li>
						<li><a href="https://www.batexi.com/a/90doew38.html">aspx生成静态页面html 例子</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zv5myv9.html">性能压测，SQL查询异常</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q1z6on59.html">iOS 实现时间线列表效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wl1mxq.html">php declare &lpar;ticks &equals; N&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnmgxd8.html">Topcoder SRM 656 &lpar;Div&period;1&rpar; 250 RandomPancakeStack - 概率&plus;记忆化搜索</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x21409.html">JSON 遍历转为Model Bean</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1n7w19.html">Oracle 存储过程&lpar;2&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z66x59.html">asp&period;net，mvc4，mysql数据库，Ef遇到问题集合</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydjjjmq.html">C&num;&mdash;集合（Collection）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1gy2j9.html">firefox 的event事件处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn7ge6q.html">你好，C&plus;&plus;（12）如何管理多个类型相同性质相同的数据？3&period;6 数组</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn7g1pq.html">使用C&num;连接ORACLE数据库</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
